﻿using Sample.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Syncfusion.Linq;
using Syncfusion.JavaScript.DataSources;

namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {            
            var DataSource1 = EmployeeRepository.GetAllRecords().ToList();
            ViewBag.Master = DataSource1;            
            return View();
        }

        public ActionResult ChildData(DataManager dm, string Country)
        {
            IEnumerable data = OrderRepository.GetAllRecords().Take(100).ToList();
            int count = data.AsQueryable().Count();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            data = operation.Execute(data, dm);
            result.result = data;
            if (dm.Where != null)
                result.count = data.AsQueryable().Count();
            else
                result.count = count;
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult BatchUpdateParent(List<EmployeeModel> changed, List<EmployeeModel> added, List<EmployeeModel> deleted)
        {
            if (changed != null)
                EmployeeRepository.Update(changed);
            if (deleted != null)
                EmployeeRepository.Delete(deleted);
            if (added != null)
                EmployeeRepository.Add(added);
            var data = EmployeeRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult BatchUpdateChild(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }        
    }

}
